"""
Autogenerated state module using `pop-create-idem <https://gitlab.com/saltstack/pop/pop-create-idem>`__

hub.exec.boto3.client.neptune.create_db_instance
hub.exec.boto3.client.neptune.delete_db_instance
hub.exec.boto3.client.neptune.describe_db_instances
hub.exec.boto3.client.neptune.modify_db_instance
hub.exec.boto3.client.neptune.reboot_db_instance
"""



from typing import *
import dict_tools.differ as differ
async def present(hub, ctx, name: Text, db_instance_identifier: Text, db_instance_class: Text, engine: Text, db_name: Text = None, allocated_storage: int = None, master_username: Text = None, master_user_password: Text = None, db_security_groups: List = None, vpc_security_group_ids: List = None, availability_zone: Text = None, db_subnet_group_name: Text = None, preferred_maintenance_window: Text = None, db_parameter_group_name: Text = None, backup_retention_period: int = None, preferred_backup_window: Text = None, port: int = None, multi_az: bool = None, engine_version: Text = None, auto_minor_version_upgrade: bool = None, license_model: Text = None, iops: int = None, option_group_name: Text = None, character_set_name: Text = None, publicly_accessible: bool = None, tags: List = None, db_cluster_identifier: Text = None, storage_type: Text = None, tde_credential_arn: Text = None, tde_credential_password: Text = None, storage_encrypted: bool = None, kms_key_id: Text = None, domain: Text = None, copy_tags_to_snapshot: bool = None, monitoring_interval: int = None, monitoring_role_arn: Text = None, domain_iam_role_name: Text = None, promotion_tier: int = None, timezone: Text = None, enable_iam_database_authentication: bool = None, enable_performance_insights: bool = None, performance_insights_kms_key_id: Text = None, enable_cloudwatch_logs_exports: List = None, deletion_protection: bool = None)  -> Dict[str, Any]:
    r'''
    **Autogenerated function**
    
    Creates a new DB instance.

    Args:
        name(Text): A name, ID, or JMES search path to identify the resource.
        db_name(Text, optional): Not supported. Defaults to None.
        db_instance_identifier(Text): The DB instance identifier. This parameter is stored as a lowercase string. Constraints:   Must
            contain from 1 to 63 letters, numbers, or hyphens.   First character must be a letter.   Cannot
            end with a hyphen or contain two consecutive hyphens.   Example: mydbinstance.
        allocated_storage(int, optional): Not supported by Neptune. Defaults to None.
        db_instance_class(Text): The compute and memory capacity of the DB instance, for example, db.m4.large. Not all DB
            instance classes are available in all Amazon Regions.
        engine(Text): The name of the database engine to be used for this instance. Valid Values: neptune.
        master_username(Text, optional): Not supported by Neptune. Defaults to None.
        master_user_password(Text, optional): Not supported by Neptune. Defaults to None.
        db_security_groups(List, optional): A list of DB security groups to associate with this DB instance. Default: The default DB
            security group for the database engine. Defaults to None.
        vpc_security_group_ids(List, optional): A list of EC2 VPC security groups to associate with this DB instance. Not applicable. The
            associated list of EC2 VPC security groups is managed by the DB cluster. For more information,
            see CreateDBCluster. Default: The default EC2 VPC security group for the DB subnet group's VPC. Defaults to None.
        availability_zone(Text, optional):  The EC2 Availability Zone that the DB instance is created in Default: A random, system-chosen
            Availability Zone in the endpoint's Amazon Region.  Example: us-east-1d   Constraint: The
            AvailabilityZone parameter can't be specified if the MultiAZ parameter is set to true. The
            specified Availability Zone must be in the same Amazon Region as the current endpoint. Defaults to None.
        db_subnet_group_name(Text, optional): A DB subnet group to associate with this DB instance. If there is no DB subnet group, then it is
            a non-VPC DB instance. Defaults to None.
        preferred_maintenance_window(Text, optional): The time range each week during which system maintenance can occur, in Universal Coordinated
            Time (UTC).  Format: ddd:hh24:mi-ddd:hh24:mi  The default is a 30-minute window selected at
            random from an 8-hour block of time for each Amazon Region, occurring on a random day of the
            week. Valid Days: Mon, Tue, Wed, Thu, Fri, Sat, Sun. Constraints: Minimum 30-minute window. Defaults to None.
        db_parameter_group_name(Text, optional): The name of the DB parameter group to associate with this DB instance. If this argument is
            omitted, the default DBParameterGroup for the specified engine is used. Constraints:   Must be 1
            to 255 letters, numbers, or hyphens.   First character must be a letter   Cannot end with a
            hyphen or contain two consecutive hyphens. Defaults to None.
        backup_retention_period(int, optional): The number of days for which automated backups are retained. Not applicable. The retention
            period for automated backups is managed by the DB cluster. For more information, see
            CreateDBCluster. Default: 1 Constraints:   Must be a value from 0 to 35   Cannot be set to 0 if
            the DB instance is a source to Read Replicas. Defaults to None.
        preferred_backup_window(Text, optional):  The daily time range during which automated backups are created. Not applicable. The daily time
            range for creating automated backups is managed by the DB cluster. For more information, see
            CreateDBCluster. Defaults to None.
        port(int, optional): The port number on which the database accepts connections. Not applicable. The port is managed
            by the DB cluster. For more information, see CreateDBCluster.  Default: 8182  Type: Integer. Defaults to None.
        multi_az(bool, optional): Specifies if the DB instance is a Multi-AZ deployment. You can't set the AvailabilityZone
            parameter if the MultiAZ parameter is set to true. Defaults to None.
        engine_version(Text, optional): The version number of the database engine to use. Currently, setting this parameter has no
            effect. Defaults to None.
        auto_minor_version_upgrade(bool, optional): Indicates that minor engine upgrades are applied automatically to the DB instance during the
            maintenance window. Default: true. Defaults to None.
        license_model(Text, optional): License model information for this DB instance.  Valid values: license-included | bring-your-
            own-license | general-public-license. Defaults to None.
        iops(int, optional): The amount of Provisioned IOPS (input/output operations per second) to be initially allocated
            for the DB instance. Defaults to None.
        option_group_name(Text, optional):  (Not supported by Neptune). Defaults to None.
        character_set_name(Text, optional):  (Not supported by Neptune). Defaults to None.
        publicly_accessible(bool, optional): This flag should no longer be used. Defaults to None.
        tags(List, optional): The tags to assign to the new instance. Defaults to None.
        db_cluster_identifier(Text, optional): The identifier of the DB cluster that the instance will belong to. For information on creating a
            DB cluster, see CreateDBCluster. Type: String. Defaults to None.
        storage_type(Text, optional): Specifies the storage type to be associated with the DB instance. Not applicable. Storage is
            managed by the DB Cluster. Defaults to None.
        tde_credential_arn(Text, optional): The ARN from the key store with which to associate the instance for TDE encryption. Defaults to None.
        tde_credential_password(Text, optional): The password for the given ARN from the key store in order to access the device. Defaults to None.
        storage_encrypted(bool, optional): Specifies whether the DB instance is encrypted. Not applicable. The encryption for DB instances
            is managed by the DB cluster. For more information, see CreateDBCluster. Default: false. Defaults to None.
        kms_key_id(Text, optional): The Amazon KMS key identifier for an encrypted DB instance. The KMS key identifier is the Amazon
            Resource Name (ARN) for the KMS encryption key. If you are creating a DB instance with the same
            Amazon account that owns the KMS encryption key used to encrypt the new DB instance, then you
            can use the KMS key alias instead of the ARN for the KM encryption key. Not applicable. The KMS
            key identifier is managed by the DB cluster. For more information, see CreateDBCluster. If the
            StorageEncrypted parameter is true, and you do not specify a value for the KmsKeyId parameter,
            then Amazon Neptune will use your default encryption key. Amazon KMS creates the default
            encryption key for your Amazon account. Your Amazon account has a different default encryption
            key for each Amazon Region. Defaults to None.
        domain(Text, optional): Specify the Active Directory Domain to create the instance in. Defaults to None.
        copy_tags_to_snapshot(bool, optional): True to copy all tags from the DB instance to snapshots of the DB instance, and otherwise false.
            The default is false. Defaults to None.
        monitoring_interval(int, optional): The interval, in seconds, between points when Enhanced Monitoring metrics are collected for the
            DB instance. To disable collecting Enhanced Monitoring metrics, specify 0. The default is 0. If
            MonitoringRoleArn is specified, then you must also set MonitoringInterval to a value other than
            0. Valid Values: 0, 1, 5, 10, 15, 30, 60. Defaults to None.
        monitoring_role_arn(Text, optional): The ARN for the IAM role that permits Neptune to send enhanced monitoring metrics to Amazon
            CloudWatch Logs. For example, arn:aws:iam:123456789012:role/emaccess. If MonitoringInterval is
            set to a value other than 0, then you must supply a MonitoringRoleArn value. Defaults to None.
        domain_iam_role_name(Text, optional): Specify the name of the IAM role to be used when making API calls to the Directory Service. Defaults to None.
        promotion_tier(int, optional): A value that specifies the order in which an Read Replica is promoted to the primary instance
            after a failure of the existing primary instance.  Default: 1 Valid Values: 0 - 15. Defaults to None.
        timezone(Text, optional): The time zone of the DB instance. Defaults to None.
        enable_iam_database_authentication(bool, optional): Not supported by Neptune (ignored). Defaults to None.
        enable_performance_insights(bool, optional):  (Not supported by Neptune). Defaults to None.
        performance_insights_kms_key_id(Text, optional):  (Not supported by Neptune). Defaults to None.
        enable_cloudwatch_logs_exports(List, optional): The list of log types that need to be enabled for exporting to CloudWatch Logs. Defaults to None.
        deletion_protection(bool, optional): A value that indicates whether the DB instance has deletion protection enabled. The database
            can't be deleted when deletion protection is enabled. By default, deletion protection is
            disabled. See Deleting a DB Instance. DB instances in a DB cluster can be deleted even when
            deletion protection is enabled in their parent DB cluster. Defaults to None.

    Returns:
        Dict[str, Any]

    Examples:

        .. code-block:: sls

            resource_is_present:
              aws_auto.neptune.db_instance.present:
                - name: value
                - db_instance_identifier: value
                - db_instance_class: value
                - engine: value
    '''
    
    result = dict(comment="", changes= None, name=name, result=True)
    ret = await hub.exec.boto3.client.neptune.db_instance.id(
        ctx,
        jmes_path=name
    )
    if ret["status"]:
        # name is now the first id that matched the JMES search path
        name = ret["ret"]
    

    
    before = await hub.exec.boto3.client.neptune.describe_db_instances(name)

    if before:
        result["comment"] = f"'{name}' already exists"
    else:
        try:
            ret = await hub.exec.boto3.client.neptune.create_db_instance(
                ctx,
                
                
                **{"DBName": db_name, "DBInstanceIdentifier": db_instance_identifier, "AllocatedStorage": allocated_storage, "DBInstanceClass": db_instance_class, "Engine": engine, "MasterUsername": master_username, "MasterUserPassword": master_user_password, "DBSecurityGroups": db_security_groups, "VpcSecurityGroupIds": vpc_security_group_ids, "AvailabilityZone": availability_zone, "DBSubnetGroupName": db_subnet_group_name, "PreferredMaintenanceWindow": preferred_maintenance_window, "DBParameterGroupName": db_parameter_group_name, "BackupRetentionPeriod": backup_retention_period, "PreferredBackupWindow": preferred_backup_window, "Port": port, "MultiAZ": multi_az, "EngineVersion": engine_version, "AutoMinorVersionUpgrade": auto_minor_version_upgrade, "LicenseModel": license_model, "Iops": iops, "OptionGroupName": option_group_name, "CharacterSetName": character_set_name, "PubliclyAccessible": publicly_accessible, "Tags": tags, "DBClusterIdentifier": db_cluster_identifier, "StorageType": storage_type, "TdeCredentialArn": tde_credential_arn, "TdeCredentialPassword": tde_credential_password, "StorageEncrypted": storage_encrypted, "KmsKeyId": kms_key_id, "Domain": domain, "CopyTagsToSnapshot": copy_tags_to_snapshot, "MonitoringInterval": monitoring_interval, "MonitoringRoleArn": monitoring_role_arn, "DomainIAMRoleName": domain_iam_role_name, "PromotionTier": promotion_tier, "Timezone": timezone, "EnableIAMDatabaseAuthentication": enable_iam_database_authentication, "EnablePerformanceInsights": enable_performance_insights, "PerformanceInsightsKMSKeyId": performance_insights_kms_key_id, "EnableCloudwatchLogsExports": enable_cloudwatch_logs_exports, "DeletionProtection": deletion_protection}
            )
            result["result"] = ret["status"]
            if not result["result"]:
                result["comment"] = ret["comment"]
                return result
            ret["comment"] = f"Created '{name}'"
        except hub.tool.boto3.exception.ClientError as e:
            result["comment"] = f"{e.__class__.__name__}: {e}"

    
    # TODO perform other modifications as needed here
    ...

    after = await hub.exec.boto3.client.neptune.describe_db_instances(name)
    result["changes"] = differ.deep_diff(before, after)
    return result

async def absent(hub, ctx, name: Text, db_instance_identifier: Text, skip_final_snapshot: bool = None, final_db_snapshot_identifier: Text = None)  -> Dict[str, Any]:
    r'''
    **Autogenerated function**
    
    The DeleteDBInstance action deletes a previously provisioned DB instance. When you delete a DB instance, all
    automated backups for that instance are deleted and can't be recovered. Manual DB snapshots of the DB instance
    to be deleted by DeleteDBInstance are not deleted.  If you request a final DB snapshot the status of the Amazon
    Neptune DB instance is deleting until the DB snapshot is created. The API action DescribeDBInstance is used to
    monitor the status of this operation. The action can't be canceled or reverted once submitted. Note that when a
    DB instance is in a failure state and has a status of failed, incompatible-restore, or incompatible-network, you
    can only delete it when the SkipFinalSnapshot parameter is set to true. You can't delete a DB instance if it is
    the only instance in the DB cluster, or if it has deletion protection enabled.

    Args:
        name(Text): A name, ID, or JMES search path to identify the resource.
        db_instance_identifier(Text): The DB instance identifier for the DB instance to be deleted. This parameter isn't case-
            sensitive. Constraints:   Must match the name of an existing DB instance.
        skip_final_snapshot(bool, optional):  Determines whether a final DB snapshot is created before the DB instance is deleted. If true is
            specified, no DBSnapshot is created. If false is specified, a DB snapshot is created before the
            DB instance is deleted. Note that when a DB instance is in a failure state and has a status of
            'failed', 'incompatible-restore', or 'incompatible-network', it can only be deleted when the
            SkipFinalSnapshot parameter is set to "true". Specify true when deleting a Read Replica.  The
            FinalDBSnapshotIdentifier parameter must be specified if SkipFinalSnapshot is false.  Default:
            false. Defaults to None.
        final_db_snapshot_identifier(Text, optional):  The DBSnapshotIdentifier of the new DBSnapshot created when SkipFinalSnapshot is set to false.
            Specifying this parameter and also setting the SkipFinalShapshot parameter to true results in an
            error.  Constraints:   Must be 1 to 255 letters or numbers.   First character must be a letter
            Cannot end with a hyphen or contain two consecutive hyphens   Cannot be specified when deleting
            a Read Replica. Defaults to None.

    Returns:
        Dict[str, Any]

    Examples:

        .. code-block:: sls

            resource_is_absent:
              aws_auto.neptune.db_instance.absent:
                - name: value
                - db_instance_identifier: value
    '''
    
    result = dict(comment="", changes= None, name=name, result=True)
    ret = await hub.exec.boto3.client.neptune.db_instance.id(
        ctx,
        jmes_path=name
    )
    if ret["status"]:
        # name is now the first id that matched the JMES search path
        name = ret["ret"]
    

    

    before = await hub.exec.boto3.client.neptune.describe_db_instances(name)

    if not before:
        result["comment"] = f"'{name}' already absent"
    else:
        try:
            ret = await hub.exec.boto3.client.neptune.delete_db_instance(
                ctx,
                
                
                **{"DBInstanceIdentifier": db_instance_identifier, "SkipFinalSnapshot": skip_final_snapshot, "FinalDBSnapshotIdentifier": final_db_snapshot_identifier}
            )
            result["result"] = ret["status"]
            if not result["result"]:
                result["comment"] = ret["comment"]
                return result
            result["comment"] = f"Deleted '{name}'"
        except hub.tool.boto3.exception.ClientError as e:
            result["comment"] = f"{e.__class__.__name__}: {e}"

    

    after = await hub.exec.boto3.client.neptune.describe_db_instances(name)
    result["changes"] = differ.deep_diff(before, after)
    return result

